<?php if (!defined('PmWiki')) exit();

/*  rater.php, copyright 2008 Hans Bracker, 
    this script is adaptated and modified for PmWiki from PHP 5 Star Rating System
    http://gr0w.com/articles/code/php_5_star_rating_system_using_hreview/
    
    You can redistribute this file and/or modify
    it under the terms of the GNU General Public License as published
    by the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.  See pmwiki.php for full details.
    
    For instructions see  www.pmwiki.org/wiki/Cookbook.StarRater  
*/
$RecipeInfo['StarRater']['Version'] = '2014-10-09';

//Default settings, for customisations in config.php
//authid and ip based voting restrictions; authid takes precedence over ip 
SDV($Rater['authid_voting_restrictions'], false);
SDV($Rater['ip_voting_restrictions'], true); // restrict ip address voting (true or false)
SDV($Rater['vote_quantity'], 1); // how many times a user or ip address can vote
//PmWiki security restrictions
SDV($HandleAuth['rater'], 'read'); // Set to 'edit' if only edit authorised users shall be able to vote.
// messages
SDV($Rater['already_rated_msg'], "$[You have already rated this item.] $[You were allowed] ".$Rater['vote_quantity']." $[vote(s)].");
SDV($Rater['not_selected_msg'], "$[You have not selected a rating value.]");
SDV($Rater['thankyou_msg'], "$[Thank you for voting!]");
SDV($Rater['notauthorised_msg'], "$[Sorry, you are not authorised to vote!]");
SDV($Rater['generic_text'], "$[this item]"); // generic item text
SDV($Rater['eol_char'], "\n"); // end of line character. may want to change for different operating systems
SDV($Rater['button_text'], '$[Rate]');
SDV($Rater['reverse_buttons'], 1); //radio buttons "Poor" -left to "Excellent" -right
SDV($Rater['zero_choice'], 0); //no zero star choice (5 choices). set to 1 for adding zero star choice (6 choices)
SDV($Rater['header'], "!!!!!$[Rate] {name}");
SDV($Rater['stats'], "[-Rating {ratingD}/-][--10--][- from {votes} votes-]"); //default stats template
SDV($Rater['not_rated'], "Not rated yet");
SDV($Rater['allvotes'], 0); //set to 1 to show vote distribution statistics (or set allvotes=1 in (:rater:) markup
SDV($Rater['summary'], XL('Rated item')); //text for RecentChanges summary, followed by item id
SDV($Rater['rating_in_summary'], 0); //set to 1 to show individual rating in RecentChanges summary
SDV($Rater['rating_in_summary_unit'], XL('stars')); //shows rating unit e.g. 'stars' in RecentChanges summary if rating_in_summary set to 1

// choices texts
SDV($Rater['5star'], XL('Excellent'));
SDV($Rater['4star'], XL('Very Good'));
SDV($Rater['3star'], XL('Good'));
SDV($Rater['2star'], XL('Fair'));
SDV($Rater['1star'], XL('Poor'));
SDV($Rater['0star'], XL('Avoid'));

SDV($Rater['star_color'], "yellow"); //default star color
SDV($Rater['star_basename'], "star.gif");
$Rater['star_idx'] = array('00','05','10','15','20','25','30','35','40','45','50');

// file paths etc; slash at right needed!
SDV($Rater['imgdirurl'], "$PubDirUrl/rater/img/"); 
SDV($Rater['logdir'], "pub/rater/logs/");
SDV($Rater['logdirurl'], "$PubDirUrl/rater/logs/");

mkdirp($Rater['logdir']);

SDV($Rater['file_extension'], ".rating");
SDV($Rater['file_prefix'], '$pagename.');

// Rating action
$HandleActions['rater'] = 'HandleRater';
function HandleRater($pagename, $auth) {
	global $Rater, $AuthId, $Author;
	//set log file
	$id = $_POST["rs_id"];
	$Rater['id'] = $id;
	if(!CondAuth($pagename,$auth)) {
		$Rater[$id]['msg'] = $Rater['notauthorised_msg']; 
		HandleBrowse($pagename);
		exit; 
	}	
	$fn = $Rater['file_prefix'].$Rater['id'].$Rater['file_extension'];
	$filename = FmtPageName($Rater['logdir'].$fn, $pagename);
	$fileurl = FmtPageName($Rater['logdirurl'].$fn, $pagename);
	if (isset($_POST["rating_$id"])) {
		//get rating choice
		while(list($key,$val) = each($_POST["rating_$id"])) {
			$rating = $val;
		}
		//log user name
		if ($AuthId!='') $user = $AuthId;
		elseif(isset($Author)) $user = $Author;
		else $user = 'anonymous';
  	//log ip address
  	$ipaddress = getenv("REMOTE_ADDR");
  	//open log file 	
		$file = fopen($filename, "a+");
		$text = "";
		$text = rtrim(fread($file, 1024*8),$Rater['eol_char']);
		$enablevote = 1;
		if($text>"") {
	   	$data = explode($Rater['eol_char'], $text);
	   	$votes = count($data)+1;
	   	$sum = 0; 
	   	$vote_count = 0;
	   	foreach ($data as $d) {
	    		if ($d=='') continue; 
	    		$item = explode("|",$d);
		    	$sum += $item[0];
	   		//check authid or ip address if user has voted before
	   		if ($Rater['authid_voting_restrictions'] || $Rater['ip_voting_restrictions']) {
			   		if ($Rater['authid_voting_restrictions']) {
			    			$oldauthid = str_replace($Rater['eol_char'],"", $item[2]);
			    			if ($user==$oldauthid) $vote_count++;
			   		}
		   			elseif ($Rater['ip_voting_restrictions']) {
		    				$oldip = str_replace($Rater['eol_char'],"", $item[1]);
		    				if ($ipaddress==$oldip) $vote_count++;
		    		}
				   	if($Rater['ip_vote_qty']) $Rater['vote_quantity'] = $Rater['ip_vote_qty']; //backwards naming compatibility
				   	if($vote_count > ($Rater['vote_quantity'] - 1)) {
				   		$Rater[$id]['msg'] = $Rater['already_rated_msg'];
				   		$enablevote = 0;
				   	} else 
				   		$Rater[$id]['msg'] = $Rater['thankyou_msg'];
		   	} else 
		   		$Rater[$id]['msg'] = $Rater['thankyou_msg'];
	  		} 
	  	//new vote
	  	} else {
	  		$Rater[$id]['msg']=$Rater['thankyou_msg'];
	  		$votes = 1; 
  		}
		if ($enablevote==1) fwrite($file, $rating."|".$ipaddress."|".$user.$Rater['eol_char']);
		fclose($file);
		$allrating = round(20*($sum+$rating)/$votes, 2); #ECHO " SUM=".$sum." VOTES=".$votes." ALL=".$allrating."<br />";
		if ($enablevote==1) RaterUpdatePTV($pagename, 'Rating'.$id, $rating, $allrating);
	} else {
		$Rater[$id]['msg'] = $Rater['not_selected_msg'];
 	}
	HandleBrowse($pagename);
	exit;
}

//add or update {$:Rating..} PTV
function RaterUpdatePTV($pagename, $ptv, $rating, $val) {
	global $PageTextVarPatterns, $IsPagePosted, $ChangeSummary, $Rater, $EnablePostAuthorRequired, $Author;
	if (!$Author && $EnablePostAuthorRequired==1) $Author='anonymous';
	$EnablePostAuthorRequired = 0;
	$page = RetrieveAuthPage($pagename, 'read', false, READPAGE_CURRENT);
	$text = $page['text'];
	$var = ''; $ratcnt = 0;
	$ratercnt = preg_match_all('/\\(:rater\\s*(.*?)\\s*:\\)/s', $text, $rm);
	if (preg_match_all("/(\\(:(Rating[-_a-zA-Z0-9]+):\\s*)(.*?)(:\\))/s", $text, $match, PREG_SET_ORDER)) {
		foreach($match as $m) {
			$var = $m[2]; 
			if ($var!=$ptv) continue;
			$text = str_replace($m[0], $m[1] . $val . $m[4], $text);
			break;
		}
	}
	if($var!=$ptv) {
		$text .= "(:$ptv: $val:)\n";
	}
	//update page
	$new = $page;
	$new['text'] = $text;
	$IsPagePosted = 0;
	$rating = ($Rater['rating_in_summary']==1) ? ": ".$rating." ".$Rater['rating_in_summary_unit'] : "";
	$rater_id = ($Rater['id']!=1 || $ratercnt > 1) ? " ".$Rater['id'] : "";
  $ChangeSummary = $Rater['summary'].$rater_id.$rating;
	$new["csum:$Now"] = $new['csum'] = $ChangeSummary;
	$IsPagePosted = UpdatePage($pagename, $page, $new);
	return '';
}

// Output
Markup_e('rater','<{$var}','/\\(:rater\\s*(.*?)\\s*:\\)/s',
      "RaterMarkup(\$pagename, \$m[1])");
function RaterMarkup($pagename, $args) {
	global $ScriptUrl, $EnablePathInfo, $FmtPV, $Rater;
	if (!PageExists($pagename)) return '';
	$group = PageVar($pagename, '$Group');
	$name = PageVar($pagename, '$Name');
	$PageUrl = ($EnablePathInfo) 
         ? "$ScriptUrl/$group/$name"
         : "$ScriptUrl?n=$group.$name";
	$args = ParseArgs($args);
	$args[''] = (array)@$args[''];
	$id = (isset($args['id'])) ? $args['id'] : array_shift($args['']); 
	if (!isset($id)) $id = 1;
	$id = FmtPagename($id, $pagename);
	if (!preg_match("/^[-_a-zA-Z0-9]*$/",$id,$m)) 
		$id = preg_replace("/[^-_a-zA-Z0-9]/", "_", $id);
		#return "'''%red%Error: wrong characters in rater markup id!'''";
	$name = (isset($args['name'])) ? $args['name'] : array_shift($args['']);
	if (!isset($name)) $name = $Rater['generic_text'];
	$header = (isset($args['head'])) ? $args['head'] : $Rater['header'];
	$header = str_replace("{name}", $name, $header);
	if ($args['zero']==1) $zero = 0;
	else $zero = ($Rater['zero_choice']==1) ? 0 : 1;
	for ($i=$zero; $i<=5; $i++)  
			$choice[$i] = (isset($args[$i.'star'])) ? $args[$i.'star'] : $Rater[$i.'star'];
	$label = (isset($args['label'])) ? $args['label'] : $Rater['button_text'];
	$color = (isset($args['color'])) ? $args['color'] : $Rater['star_color'];	
	$rating = 0;	
			
	//get current rating
	$fn = $Rater['file_prefix'].$id.$Rater['file_extension'];
	$filename = FmtPageName($Rater['logdir'].$fn, $pagename);
	$fileurl = FmtPageName($Rater['logdirurl'].$fn, $pagename);
	if (is_file($filename)) {
		$file = fopen($filename,"r");
		$str = ""; $votes = 0;
		$str = fread($file, 1024*8);
		if($str!="") {
			$data = explode($Rater['eol_char'], $str);
			$sum = 0; $votes = 0;
			for ($i=0; $i<=5; $i++) $vsum[$i] = 0;
			foreach($data as $k => $d) {
				if (!strpos($d,'|')) continue; 
				$d = explode("|",$d);
				$sum += $d[0];
				for ($i=$zero; $i<=5; $i++)
					if ($d[0]==$i) { $vsum[$i]++; $votes++; }
			}
			// calculate rating
			if ($votes>0)
				$rating = round(20*$sum/$votes, 2);
		}
		fclose($file);
	} 
	
	//assign verbal rating
	    if ($rating > 90) $ratingA = $choice[5];
	elseif ($rating > 70) $ratingA = $choice[4];
	elseif ($rating > 50) $ratingA = $choice[3];
	elseif ($rating > 30) $ratingA = $choice[2];
	elseif ($rating > 10) $ratingA = $choice[1];
	elseif ($rating >= 0) $ratingA = $choice[0];
	
	//vote distribution
	$vsep = " &ndash; ";
	$btnorder = (isset($args['reverse'])) ? $args['reverse'] : $Rater['reverse_buttons'] ;
	if ($btnorder==1)
		$distrib = "[-$[Vote Distribution]: ".($Rater['zero_choice']==1 ? $vsum[0].$vsep : '').$vsum[1].$vsep.$vsum[2].$vsep.$vsum[3].$vsep.$vsum[4].$vsep.$vsum[5]."-]";	
	else	
		$distrib = "[-$[Vote Distribution]: ".$vsum[5].$vsep.$vsum[4].$vsep.$vsum[3].$vsep.$vsum[2].$vsep.$vsum[1].($Rater['zero_choice']==1 ? $vsep.$vsum[0] : '')."-]";

	//various rating output formats
	$ratingB = number_format((0.05*$rating), 1, '.', ''); // star number, 1 decimal place 
	$ratingC = number_format(($rating), 0, '.', '');  // percent number
	$ratingD = number_format((0.1*$rating), 1, '.', ''); // 'out of ten' number, 1 decimal place
	
	// assign statistics
	$stats = isset($args['stats']) ? $args['stats'] : $Rater['stats'];
	$stats = str_replace("{ratingA}", $ratingA, $stats);	
	$stats = str_replace("{ratingB}", $ratingB, $stats);	
	$stats = str_replace("{ratingC}", $ratingC, $stats);
	$stats = str_replace("{ratingD}", $ratingD, $stats);
	$stats = str_replace("{rating}", $rating, $stats);	
	$stats = str_replace("{votes}", $votes, $stats);
	if ($votes==0) $stats = $Rater['not_rated'];
	if($stats==='0') $stats= '';	
	
	$radiobtn = '';
	if ($btnorder==1)
		for ($i=$zero; $i<=5; $i++)	
			$radiobtn .= "(:input radio id=rating_".$id.$i." rating_".$id."[] ".$i." :)(:label rating_".$id.$i." '".$choice[$i]."':) ";
	else	
		for ($i=5; $i>=$zero; $i--)	
			$radiobtn .= "(:input radio id=rating_".$id.$i." rating_".$id."[] ".$i." :)(:label rating_".$id.$i." '".$choice[$i]."':) ";

	//create output	
	$RaterMarkupFmt = 
		">>rater<<\n$header\n"
	   .RaterFmt($pagename, $rating, 'stars', $color)
	   ." $stats\n"
		.(($args['allvotes']==1 || $Rater['allvotes']==1) && $args['allvotes']!=='0' && $votes>0 ? "\\\\\n$distrib" : "")
		."(:input form \"$PageUrl\":)\n"
		."(:div1:)(:input hidden n $pagename:)"
		."(:input hidden action rater:)"
		."(:input hidden rs_id $id:)"
		.$radiobtn
		."(:input submit post '$label' class=inputbutton :)\\\\\n"
		."'''{$Rater[$id]['msg']}'''\n"
		."(:div1end:)(:input end:)\n"
		.">><<";
	$out = MarkupToHTML($pagename, $RaterMarkupFmt);
	return Keep($out);
}

$MarkupExpr['rater'] = 'RaterFmt($pagename,$args[0],$args[1],$args[2])';

function RaterFmt($pagename, $rating, $fmt, $color) {
	global $Rater;
	if (!isset($color)) $color = $Rater['star_color'];
	foreach($Rater['star_idx'] as $i)
		$star[$i] = $color.$i.$Rater['star_basename'];
	//assign star image
	    if ($rating > 90) { $img = $Rater['imgdirurl'].$star['50']; $img_txt = "5"; }
	elseif ($rating > 80) { $img = $Rater['imgdirurl'].$star['45']; $img_txt = "4.5"; }
	elseif ($rating > 70) { $img = $Rater['imgdirurl'].$star['40']; $img_txt = "4"; }
	elseif ($rating > 60) { $img = $Rater['imgdirurl'].$star['35']; $img_txt = "3.5"; }
	elseif ($rating > 50) { $img = $Rater['imgdirurl'].$star['30']; $img_txt = "3"; }
	elseif ($rating > 40) { $img = $Rater['imgdirurl'].$star['25']; $img_txt = "2.5"; }
	elseif ($rating > 30) { $img = $Rater['imgdirurl'].$star['20']; $img_txt = "2"; }
	elseif ($rating > 20) { $img = $Rater['imgdirurl'].$star['15']; $img_txt = "1.5"; }
	elseif ($rating > 10) { $img = $Rater['imgdirurl'].$star['10']; $img_txt = "1"; }	
	elseif ($rating >  1) { $img = $Rater['imgdirurl'].$star['05']; $img_txt = "0.5"; }
	elseif ($rating <= 0) { $img = $Rater['imgdirurl'].$star['00']; $img_txt = "0"; } 
	
	//assign verbal rating
	    if ($rating > 90) $verbal = $Rater['5star'];
	elseif ($rating > 70) $verbal = $Rater['4star'];
	elseif ($rating > 50) $verbal = $Rater['3star'];
	elseif ($rating > 30) $verbal = $Rater['2star'];
	elseif ($rating > 10) $verbal = $Rater['1star'];
	elseif ($rating >= 0) $verbal = $Rater['0star'];	
		
	//output format (default stars image)	
	switch ($fmt) {
		case '':
		case 'stars': $out = "<img src='$img' alt='$img_txt ".XL('stars')."' title='$img_txt ".XL('stars')."' />"; break;
		case '10': $out = number_format((0.1*$rating), 1, '.', ''); break;
		case '100': $out = number_format(($rating), 0, '.', ''); break;
		case '5': $out = number_format((0.05*$rating), 1, '.', ''); break;
		case 'verbal': $out = $verbal;
	}	
	return Keep($out);	
}

//add (:label:) markup for better radio button choices
//(adapted from Cookbook.FormExtensions by Ben Stallings)
Markup_e('label2', '>input',
  '/\\(:label\\s+(.*?)\\s+(.*?):\\)/i',
	"InputLabel2(\$m[1], \$m[2])");
function InputLabel2($id, $label) {
	return "<label for='$id'>".trim($label, "'\" ")."</label>";
}

//add order=Rating numerical pagelist order by PTV 'Rating1' values
// ('Rating1' is the default if no id is specified)
$PageListSortCmp['Rating'] = 'NumericDataCompare($x, $y, "Rating1")';

function NumericDataCompare($x, $y, $var) {
	$datax = PageTextVar($x, $var);
	$datay = PageTextVar($y, $var);
	return $datay - $datax;
}